<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>guimaker</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="gui2builder.html">&lt;&lt; gui2builder</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="inputui.html">inputui &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">GUI Tools</a> &gt;&gt; <a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a> &gt; guimaker</span>

    <br /><br />
    <div class="info"></div>

  <div class="refnamediv"><h1 class="refname">guimaker</h1><p class="refpurpose">Create a graphical user interface with a minimum of programming.</p></div>



<div class="refsynopsisdiv"><h3 class="title">Calling Sequence</h3>
   <div class="synopsis"><pre><span class="default">[</span><span class="default">val1</span><span class="default">,</span><span class="default">val2</span><span class="default">,...]=</span><span class="functionid">guimaker</span><span class="default">(</span><span class="default">page</span><span class="default">,[</span><span class="default">guiProp</span><span class="default">],[</span><span class="default">DefProp</span><span class="default">],[</span><span class="default">Flag</span><span class="default">]) </span><span class="comment">// interactive mode return user input from objects in the gui</span>
<span class="default">sci</span><span class="default">=</span><span class="functionid">guimaker</span><span class="default">(</span><span class="default">page</span><span class="default">,[</span><span class="default">guiProp</span><span class="default">],[</span><span class="default">DefProp</span><span class="default">],1) </span><span class="comment">// return the Scilab source code required for generation of the gui</span>
<span class="default">links</span><span class="default">=</span><span class="functionid">guimaker</span><span class="default">(</span><span class="default">page</span><span class="default">,[</span><span class="default">guiProp</span><span class="default">],[</span><span class="default">DefProp</span><span class="default">],2) </span><span class="comment">// create gui and return a list of handles to the gui objects</span>
<span class="functionid">guimaker</span><span class="default">() </span><span class="comment">// runs a demo...</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">page :</span>
      <dd><p class="para">a list which defines the gui as a list of lines. Lines are counted from top to bottom of the gui.</p></dd></dt>
   <dt><span class="term">line :</span>
      <dd><p class="para">a line is defined as a list of objects. Empty elements are interpreted as empty places in the line.</p></dd></dt>
   <dt><span class="term">object :</span>
      <dd><p class="para">objects are defined as a list([whf],Style,String,Property1,Value1,Property2,Value2,...) or [] to indicate an empty position in the line.</p></dd></dt>
   <dt><span class="term">whf :</span>
      <dd><p class="para">OPTIONAL vector where whf(1) defines the object width relative to the width of the gui. whf(2) is the object height measured in number of lines. Default whf=[1 1]. Optional whf(3)=1 reduces the length of the object to fit into a frame.</p></dd></dt>
   <dt><span class="term">Style :</span>
      <dd><p class="para">string with the object type {pushbutton | radiobutton | checkbox | edit | text | slider | frame |listbox | popupmenu | axes}.</p></dd></dt>
   <dt><span class="term">String :</span>
      <dd><p class="para">string containing the &#0039;string&#0039; value of the object.</p></dd></dt>
   <dt><span class="term">Property :</span>
      <dd><p class="para">string with object properties like { BackgroundColor | callback | fontangle | fontsize | fontunits | fontname | ForegroundColor | Horizontalalignment | ListboxTop | Max | Min | SliderStep | String | Tag | Units | Userdata | Value | Verticalalignment}. For axes objects see <a href="scilab://scilab.help/axes_properties" class="link">axes_properties</a>.</p></dd></dt>
   <dt><span class="term">Value :</span>
      <dd><p class="para">value of the previous object property, see <a href="scilab://scilab.help/uicontrol" class="link">uicontrol</a> for more details.</p></dd></dt>
   <dt><span class="term">guiProp :</span>
      <dd><p class="para">OPTIONAL list(Title,width,height,space,Backgroundcolor) defining gui window properties.</p></dd></dt>
   <dt><span class="term">Title :</span>
      <dd><p class="para">OPTIONAL string with name of the gui figure (default is &#0039;guimaker&#0039;).</p></dd></dt>
   <dt><span class="term">width :</span>
      <dd><p class="para">OPTIONAL width (points) of the gui window (default is 450).</p></dd></dt>
   <dt><span class="term">height :</span>
      <dd><p class="para">OPTIONAL height (points) of a line (default is 20).</p></dd></dt>
   <dt><span class="term">space :</span>
      <dd><p class="para">OPTIONAL space (points) between lines (first number) and objects on lines (second number) (default is [5 10])</p></dd></dt>
   <dt><span class="term">Backgroundcolor :</span>
      <dd><p class="para">OPTIONAL vector [R,G,B] with background color codes (default is [.95 .95 .95])</p></dd></dt>
   <dt><span class="term">DefProp :</span>
      <dd><p class="para">OPTIONAL list(Property1,Value1,...) with default properties for objects used in the gui.</p></dd></dt>
   <dt><span class="term">Flag :</span>
      <dd><p class="para">OPTIONAL =1: return Scilab code; =2: return list of object handles; =&#0034;filename&#0034;: save/retrieve user input between successive calls to guimaker (values are stored in a file named &#0039;TMPDIR\&#0039;+Flag).</p></dd></dt>
   <dt><span class="term">links :</span>
      <dd><p class="para">vector of object handles to each object in the gui (starting with the handle to the gui window and proceeds with objects from the top left to the bottom right position).</p></dd></dt>
   <dt><span class="term">val1,val2,... :</span>
      <dd><p class="para">results {string | value} from objects, except { pushbutton | text | frame }, in the order from the top left to the bottom right position in the gui. If only val1 is present the results are returned as a list.</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">guimaker is a tool for creating a graphical user interface (gui) with
a minimum of programming.</p>
   <p class="para">This is accomplished by describing the layout of the gui using a nested list.
The input parameter page consists of a list of line elements.
Each line element consists of a list of object elements, present in the line.
Each object element consists of a list of elements describing the properties
of the object (style, string and an arbitrary range of properties
and property values).</p>
   <p class="para">The layout of the gui is defined by the way lines are counted from the top
to the bottom of the gui, while objects in a line are counted from left to right.
The objects on a line are distributed evenly in the horizontal direction.
Using the optional object parameter wh one may change the size of
individual objects in the horizontal and vertical direction.</p>
   <p class="para">guimaker can be used in three different modes:
<ul class="itemizedlist"><li><p class="para">Create a gui - including the event loop:</p>
   <p class="para">Called with multiple output arguments
(<code class="literal">[val1,val2,...]=guimaker(...)</code>)
the output arguments will be assigned values from the &#0034;string&#0034; or &#0034;value&#0034; fields
of objects present in the gui. The values are assigned to the output
arguments according to the order the objects occur in the gui, counting objects
from top left to the bottom right of the gui.</p>
   <p class="para">If only one output argument is given the object values are returned as a list.
Objects with style &#0034;pushbutton&#0034;, &#0034;text&#0034; or &#0034;frame&#0034; do not return values.</p>
   <p class="para">The gui is kept open until a callback <code class="literal">&#0039;OK=%T;&#0039;</code> is
executed by one of the objects in the GUI. If a callback
<code class="literal">&#0039;CANCEL=%T;&#0039;</code> is executed or if the gui
window is killed, all output arguments are returned empty.</p>
   <p class="para">The user must define an object (usually a pushbutton) with callback set to
<code class="literal">&#0039;OK=%T;&#0039;</code> and optionally also an object with callback set
to <code class="literal">&#0039;CANCEL=%T;&#0039;</code> - to implement a Cancel function.
If the <code class="literal">Flag</code> input parameter is set to a valid
file name the object values {string | value } will
be stored in the temporary directory <code class="literal">TMPDIR</code> under the
filename <code class="literal">Flag</code>.
Initial object values will be read from this file during future calls within
the current Scilab session.</p></li>
<li><p class="para">Creation of a gui with no event loop:</p>
   <p class="para">If the input argument <code class="literal">Flag</code> is equal to 2
guimaker will create the gui and return a vector of handles.
links(1) is the handle to the gui figure window, while link(2:$) are handles to
each object present in the gui (the handles are listed counting
from top left to bottom right in the gui).</p></li>
<li><p class="para">Create only the source code for a gui, but not the gui itself:</p>
   <p class="para">Called with one output parameter and the <code class="literal">Flag</code>
input parameter set to 1
guimaker will return the source code for the gui as a string matrix.
The resulting code can be used and modified independently of guimaker.</p></li></ul></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabcomment">// Example from http://wiki.scilab.org/howto/guicontrol</span>
<span class="scilabid">page</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span> <span class="scilabnumber">10</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">frame</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">General properties</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Particle diameter [nm]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">1000</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Particle density [g/cm3]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">1</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Gas viscosity (0C) u [N*sec/m2]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">0.0000172</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Gas density (0C), 1 atm [kg/m3]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">1.29</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Mean free path (0C), 1 atm [nm]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">67</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Gamma, Cv/Cp</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">1.4</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sutherlands temperature, [K]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">110.4</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Temperature, [K]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">300</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Volume flow rate [standard l/min]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">0.5</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span> <span class="scilabnumber">4</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">frame</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Telescope properties</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Orifice diameters [mm]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">1,1,1,1,1</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Tube diameters [mm]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">100,100,100,100,100</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Input diameters [mm]</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">edit</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">201325</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">page</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">pushbutton</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Stop</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">callback</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">OK=%t</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabopenclose">[</span><span class="scilabid">dp</span><span class="scilabdefault">,</span><span class="scilabid">rhop</span><span class="scilabdefault">,</span><span class="scilabid">mu0</span><span class="scilabdefault">,</span><span class="scilabid">rhog0</span><span class="scilabdefault">,</span><span class="scilabid">lambda0</span><span class="scilabdefault">,</span><span class="scilabid">CvCp</span><span class="scilabdefault">,</span><span class="scilabid">S</span><span class="scilabdefault">,</span><span class="scilabid">T</span><span class="scilabdefault">,</span><span class="scilabid">mdot</span><span class="scilabdefault">,</span><span class="scilabid">df</span><span class="scilabdefault">,</span><span class="scilabid">ds</span><span class="scilabdefault">,</span><span class="scilabid">pin</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">page</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Aerodynamic Lens Design</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span>

<span class="scilabcomment">// Another example from http://wiki.scilab.org/howto/guicontrol</span>
<span class="scilabid">pg</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">exposure time</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Horizontalalignment</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">center</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">slider</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Min</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">0</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Max</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">100</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Value</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">5</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">text</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">arevscale</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Horizontalalignment</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">center</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">slider</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Min</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">0</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Max</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">100</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Value</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">50</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span> <span class="scilabnumber">2</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">pushbutton</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">STOP</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">callback</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">OK=%t</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">radiobutton</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">bin x2</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">pg</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">radiobutton</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">free/trig</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabopenclose">[</span><span class="scilabid">hexp</span><span class="scilabdefault">,</span><span class="scilabid">hbri</span><span class="scilabdefault">,</span><span class="scilabid">hbin</span><span class="scilabdefault">,</span><span class="scilabid">htrig</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">pg</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">objfigure1</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">220</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">10</span> <span class="scilabnumber">10</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span>

<span class="scilabcomment">// If Flag is set to a valid file name the results are stored in TMPDIR/Flag...</span>
<span class="scilabopenclose">[</span><span class="scilabid">output</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">pg</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Change some values and press STOP</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">220</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">10</span> <span class="scilabnumber">10</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">tmp_file</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span>

<span class="scilabcomment">// ... and subsequent calls will read the initial values from TMPDIR/Flag.</span>
<span class="scilabopenclose">[</span><span class="scilabid">output</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">pg</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">.</span><span class="scilabstring">.</span><span class="scilabstring">.remembers previous values</span><span class="scilabstring">.</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">220</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">10</span> <span class="scilabnumber">10</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">tmp_file</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span>

<span class="scilabcomment">// Source code generation:</span>
<span class="scilabid">source_code</span> <span class="scilaboperator">=</span> <span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">pg</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">objfigure1</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">220</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span> <span class="scilabcomment">// The code may be used as a template.</span>
<span class="scilabid">fn</span><span class="scilaboperator">=</span><span class="scilabconstants">TMPDIR</span><span class="scilaboperator">+</span><a class="scilabcommand" href="scilab://filesep">filesep</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilaboperator">+</span><span class="scilabstring">&#0039;</span><span class="scilabstring">guitemplate.sce</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">f</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://mopen">mopen</a><span class="scilabopenclose">(</span><span class="scilabid">fn</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">w</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabcommand" href="scilab://mputl">mputl</a><span class="scilabopenclose">(</span><span class="scilabid">source_code</span><span class="scilabdefault">,</span><span class="scilabid">f</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <a class="scilabcommand" href="scilab://mclose">mclose</a><span class="scilabopenclose">(</span><span class="scilabid">f</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<a class="scilabcommand" href="scilab://editor">editor</a><span class="scilabopenclose">(</span><span class="scilabid">fn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// Use this code as basis for more advanced programming</span>

<span class="scilabcomment">// Create gui and return a list of handles to objects in the gui:</span>
<span class="scilabid">h</span><span class="scilaboperator">=</span><span class="scilabid">guimaker</span><span class="scilabopenclose">(</span><span class="scilabid">pg</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">objfigure1</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">220</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span>  <span class="scilabcomment">// returns a vector of object handles</span>
<span class="scilabcomment">// The object handles may be used in an external event control loop.</span>
<span class="scilabcomment">//</span>
<span class="scilabcomment">// -----------------------------------------</span>
<span class="scilabcomment">// See the guimaker demos for more examples.</span>
<span class="scilabcomment">// -----------------------------------------</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="inputui.html" class="link">inputui</a></li>
   <li class="member"><a href="menumaker.html" class="link">menumaker</a></li></ul></div>

<div class="refsection"><h3 class="title">Bibliography</h3>
   <p class="para">http://wiki.scilab.org/howto/guicontrol ; provides more information on gui&#0039;s in Scilab.</p></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">T. Pettersen, top@tpett.com</li></ul></div>


    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="gui2builder.html">&lt;&lt; gui2builder</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="inputui.html">inputui &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
